/* Coordinate transformations for plotting package */
/* Convertion routines yielding an integer result  */

#include "plplot.h"
#include "declare.h"

/* dcpc. converts device coordinates to physical coordinates */

PLINT dcpcx(x)
PLFLT x;
{
      return(round(dpxoff + dpxscl * x));
}

PLINT dcpcy(y)
PLFLT y;
{
      return(round(dpyoff + dpyscl * y));
}

/* mmpc. converts millimetres from bottom left-hand corner to physical */
/* coordinates */

PLINT mmpcx(x)
PLFLT x;
{
      return(round(mpxoff + mpxscl * x));
}

PLINT mmpcy(y)
PLFLT y;
{
      return(round(mpyoff + mpyscl * y));
}

/* wcpc. converts world coordinates to physical coordinates */

PLINT wcpcx(x)
PLFLT x;
{
      return(round(wpxoff + wpxscl * x));
}

PLINT wcpcy(y)
PLFLT y;
{
      return(round(wpyoff + wpyscl * y));
}

